#version 130

uniform sampler2D DiffuseSampler;
uniform sampler2D DiffuseDepthSampler;

in vec2 texCoord;
in vec2 oneTexel;
uniform mat4 ProjMat;
uniform vec2 InSize;
uniform vec2 OutSize;
uniform vec2 ScreenSize;
uniform float _FOV;

float near = 0.03;
float far = 999999.0;
float LinearizeDepth(float depth) 
{
    float z = depth * 2.0 - 1.0;
    return (near * far) / (far + near - z * (far - near));    
}

const float forca = 0.06; //quanto maior mais fraco

// Função de blend Overlay para float
float blendOverlay(float base, float blend) {
    return base < 0.5 ? (2.0 * base * blend) : (1.0 - 2.0 * (1.0 - base) * (1.0 - blend));
}

// Função de blend Overlay para vec3
vec3 blendOverlay(vec3 base, vec3 blend) {
    return vec3(blendOverlay(base.r, blend.r), blendOverlay(base.g, blend.g), blendOverlay(base.b, blend.b));
}

// Função de blend Overlay com opacidade
vec3 blendOverlay(vec3 base, vec3 blend, float opacity) {
    return (blendOverlay(base, blend) * opacity + base * (1.0 - opacity));
}

void main(){
    float linewidth =  0.0016;

    float depth = LinearizeDepth(texture2D(DiffuseDepthSampler, texCoord).r);
    float distance = length(vec3(1., (2.*texCoord - 1.) * vec2(ScreenSize.x/ScreenSize.y,1.)) * depth);

    vec2 uv = texCoord;
    float d = pow((uv.x - 0.5), 2.0) + pow((uv.y), 7.0);
    vec4 col1 = vec4(vec3((1.0-texture(DiffuseDepthSampler, texCoord).r)*500), 1.0);
    d = exp(-d) / (distance * forca); // aqui ele finaliza o depthmap
    
    // Calcula a coordenada de textura para renderizar abaixo
    vec2 uv_below = vec2(uv.x + linewidth, uv.y + linewidth);
    float depth_b = LinearizeDepth(texture2D(DiffuseDepthSampler, uv_below).r);
    vec4 col2 = vec4(vec3((1.0-texture(DiffuseDepthSampler, uv_below).r)*500.0), 1.0);
    float distance_b = length(vec3(1., (2.*uv_below - 1.) * vec2(ScreenSize.x/ScreenSize.y,1.)) * depth_b);
    float d_b = pow((uv_below.x - 0.5), 2.0) + pow((uv_below.y), 7.0);
    d_b = exp(+d_b) / (distance_b * forca); // aqui ele finaliza o depthmap
    
    // Calcula a coordenada de textura para renderizar esquerda
    vec2 uv_l = vec2(uv.x - linewidth, uv.y - linewidth);
    float depth_l = LinearizeDepth(texture2D(DiffuseDepthSampler, uv_l).r);
    float distance_l = length(vec3(1., (2.*uv_l - 1.) * vec2(ScreenSize.x/ScreenSize.y,1.)) * depth_l);
    float d_l = pow((uv_l.x - 0.5), 2.0) + pow((uv_l.y), 7.0);
    d_l = exp(+d_l) / (distance_l * forca); // aqui ele finaliza o depthmap
    vec4 col3 = vec4(vec3((1.0-texture(DiffuseDepthSampler, uv_l).r)*500.0), 1.0);
    
    //vec4 difference = col1 - col2;
    //vec4 difference1 = col1 - col3;

    // Ajusta os valores da diferença utilizando a função smoothstep()
    //vec4 adjustedDifference = smoothstep(0.1, 0.9, difference + difference1); // Brancos ficam brancos, pretos permanecem pretos


    // Amostra a cor original da textura
    vec4 center = texture2D(DiffuseSampler, texCoord.st);
    // Calcula a nova cor mesclando com o efeito de luz estilo overlay
    vec3 overlayColor = vec3(1.0, 1.0, 1.0); // Cor da luz overlay (ajuste conforme desejado)
    float opacity = 0.3; // Valor de opacidade ajustável
    vec3 overlayed = blendOverlay(center.rgb, overlayColor, 1.0) * 0.9;


    float near = 0.04;
    float far = 6;

    float d0 = 2.0 * near * far / (far + near - (2.0 * texture2D(DiffuseDepthSampler, uv).x - 1.0) * (far - near)) / far;
    float d1 = 1-2.0 * near * far / (far + near - (2.0 * texture2D(DiffuseDepthSampler, uv).x - 1.0) * (far - near)) / far;
    float d2 = 1-2.0 * near * far / (far + near - (2.0 * texture2D(DiffuseDepthSampler, uv_below).x - 1.0) * (far - near)) / far;
    float d3 = 1-2.0 * near * far / (far + near - (2.0 * texture2D(DiffuseDepthSampler, uv_l).x - 1.0) * (far - near)) / far;

    float difference = (d1 - d2)*5;
    float difference1 = (d1 - d3)*5;

    float adjustedDifference = smoothstep(0.1, 0.9, difference + difference1); // Brancos ficam brancos, pretos permanecem pretos

    gl_FragColor = vec4(center.rgb + overlayed * adjustedDifference, center.a);
    //gl_FragColor = vec4(center.rgb - adjustedDifference, center.a);
    //gl_FragColor = vec4(d0);
    //gl_FragColor = vec4(center.rgb-=adjustedDifference, center.rgb);
}